'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Handles = function (_Component) {
  _inherits(Handles, _Component);

  function Handles() {
    _classCallCheck(this, Handles);

    return _possibleConstructorReturn(this, (Handles.__proto__ || Object.getPrototypeOf(Handles)).apply(this, arguments));
  }

  _createClass(Handles, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          handles = _props.handles,
          emitMouse = _props.emitMouse,
          emitTouch = _props.emitTouch;


      var renderedChildren = children({ handles: handles, emitMouse: emitMouse, emitTouch: emitTouch });
      return renderedChildren && _react2.default.Children.only(renderedChildren);
    }
  }]);

  return Handles;
}(_react.Component);

Handles.propTypes = {
  /** @ignore */
  handles: _propTypes2.default.array,
  /** @ignore */
  emitMouse: _propTypes2.default.func,
  /** @ignore */
  emitTouch: _propTypes2.default.func,
  /**
   * A function to render the handles.
   * The function receives an object with an array of handles and functions for emitting events.
   * `({ handles, emitMouse, emitTouch }): element`
   */
  children: _propTypes2.default.func.isRequired
};

exports.default = Handles;