'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _linear = require('d3-scale/src/linear');

var _linear2 = _interopRequireDefault(_linear);

var _quantize = require('d3-scale/src/quantize');

var _quantize2 = _interopRequireDefault(_quantize);

var _Rail = require('../Rail');

var _Rail2 = _interopRequireDefault(_Rail);

var _Ticks = require('../Ticks');

var _Ticks2 = _interopRequireDefault(_Ticks);

var _Tracks = require('../Tracks');

var _Tracks2 = _interopRequireDefault(_Tracks);

var _Handles = require('../Handles');

var _Handles2 = _interopRequireDefault(_Handles);

var _modes = require('./modes');

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noop = function noop() {};

var Slider = function (_Component) {
  _inherits(Slider, _Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, (Slider.__proto__ || Object.getPrototypeOf(Slider)).call(this, props));

    _this.slider = null;

    _this.valueToPerc = (0, _linear2.default)();
    _this.valueToStep = (0, _quantize2.default)();
    _this.pixelToStep = (0, _quantize2.default)();

    _this.state = { values: [] };

    _this.onMouseMove = _this.onMouseMove.bind(_this);
    _this.onTouchMove = _this.onTouchMove.bind(_this);
    _this.onMove = _this.onMove.bind(_this);

    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onTouchStart = _this.onTouchStart.bind(_this);
    _this.onStart = _this.onStart.bind(_this);

    _this.onMouseUp = _this.onMouseUp.bind(_this);
    _this.onTouchEnd = _this.onTouchEnd.bind(_this);
    return _this;
  }

  _createClass(Slider, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          domain = _props.domain,
          defaultValues = _props.defaultValues,
          step = _props.step,
          reversed = _props.reversed;


      this.updateRange(domain, step, reversed);
      this.setState(this.getValues(defaultValues, reversed));
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(next) {
      var domain = next.domain,
          step = next.step,
          reversed = next.reversed;
      var props = this.props,
          values = this.state.values;


      if (domain[0] !== props.domain[0] || domain[1] !== props.domain[1] || step !== props.step || reversed !== props.reversed) {
        this.updateRange(domain, step, reversed);
        var updated = this.getValues(values.map(function (d) {
          return d.val;
        }), reversed);
        this.setState(updated);
        props.onUpdate(updated.values.map(function (d) {
          return d.val;
        }));
        props.onChange(updated.values.map(function (d) {
          return d.val;
        }));
      }
    }
  }, {
    key: 'getValues',
    value: function getValues(arr, reversed) {
      var _this2 = this;

      var values = [];

      var mapped = arr.map(function (val, i) {
        return { key: '$$-' + i, val: val };
      }).sort(utils.getSortByVal(reversed));

      mapped.forEach(function (_ref) {
        var key = _ref.key,
            val = _ref.val;

        var v0 = _this2.valueToStep(val);

        (0, _warning2.default)(v0 === val, 'React Electric Slide: Invalid value encountered. Changing ' + val + ' to ' + v0 + '.');

        values.push({ key: key, val: v0 });
      });

      return { values: values };
    }
  }, {
    key: 'updateRange',
    value: function updateRange(_ref2, step, reversed) {
      var _ref3 = _slicedToArray(_ref2, 2),
          min = _ref3[0],
          max = _ref3[1];

      var range = utils.getStepRange(min, max, step);

      this.valueToStep.range(range.slice()).domain([min - step / 2, max + step / 2]);

      if (reversed === true) {
        this.valueToPerc.domain([min, max]).range([100, 0]);
        range.reverse();
      } else {
        this.valueToPerc.domain([min, max]).range([0, 100]);
      }

      this.pixelToStep.range(range);

      (0, _warning2.default)(max > min, 'React Electric Slide: Max must be greater than min (even if reversed). Max is ' + max + '. Min is ' + min + '.');

      (0, _warning2.default)(range.length <= 10001, 'React Electric Slide: Increase step value. Found ' + range.length.toLocaleString() + ' values in range.');

      var last = range.length - 1;

      (0, _warning2.default)(range[reversed ? last : 0] === min && range[reversed ? 0 : last] === max, 'React Electric Slide: The range is incorrectly calculated. Check domain (min, max) and step values.');
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e, key) {
      this.onStart(e, key, false);
    }
  }, {
    key: 'onTouchStart',
    value: function onTouchStart(e, key) {
      if (utils.isNotValidTouch(e)) {
        return;
      }
      this.onStart(e, key, true);
    }
  }, {
    key: 'onStart',
    value: function onStart(e, key, isTouch) {
      var values = this.state.values;


      e.stopPropagation();
      e.preventDefault();

      var active = values.find(function (value) {
        return value.key === key;
      });

      if (active) {
        this.active = key;
        isTouch ? this.addTouchEvents() : this.addMouseEvents();
      } else {
        this.active = null;
        this.requestMove(e, isTouch);
      }
    }
  }, {
    key: 'requestMove',
    value: function requestMove(e, isTouch) {
      var prev = this.state.values,
          _props2 = this.props,
          vertical = _props2.vertical,
          reversed = _props2.reversed;
      var slider = this.slider;


      this.pixelToStep.domain(utils.getSliderDomain(slider, vertical));

      var step = void 0;

      if (isTouch) {
        step = this.pixelToStep(utils.getTouchPosition(vertical, e));
      } else {
        step = this.pixelToStep(vertical ? e.clientY : e.pageX);
      }

      var active = null;
      var lowest = Infinity;

      for (var i = 0; i < prev.length; i++) {
        var diff = Math.abs(this.valueToStep(prev[i].val) - step);

        if (diff < lowest) {
          active = prev[i].key;
          lowest = diff;
        }
      }

      if (active) {
        var next = utils.updateValues(prev, active, step, reversed);
        this.onMove(prev, next, true);
      }
    }
  }, {
    key: 'addMouseEvents',
    value: function addMouseEvents() {
      document.addEventListener('mousemove', this.onMouseMove);
      document.addEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'addTouchEvents',
    value: function addTouchEvents() {
      document.addEventListener('touchmove', this.onTouchMove);
      document.addEventListener('touchend', this.onTouchEnd);
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(e) {
      var prev = this.state.values,
          _props3 = this.props,
          vertical = _props3.vertical,
          reversed = _props3.reversed;
      var active = this.active,
          slider = this.slider;


      this.pixelToStep.domain(utils.getSliderDomain(slider, vertical));

      var step = this.pixelToStep(vertical ? e.clientY : e.pageX);
      var next = utils.updateValues(prev, active, step, reversed);

      this.onMove(prev, next);
    }
  }, {
    key: 'onTouchMove',
    value: function onTouchMove(e) {
      var prev = this.state.values,
          _props4 = this.props,
          vertical = _props4.vertical,
          reversed = _props4.reversed;
      var active = this.active,
          slider = this.slider;


      if (utils.isNotValidTouch(e)) {
        return;
      }

      this.pixelToStep.domain(utils.getSliderDomain(slider, vertical));

      var step = this.pixelToStep(utils.getTouchPosition(vertical, e));
      var next = utils.updateValues(prev, active, step, reversed);

      this.onMove(prev, next);
    }
  }, {
    key: 'onMove',
    value: function onMove(prev, next, submit) {
      var _props5 = this.props,
          mode = _props5.mode,
          onUpdate = _props5.onUpdate,
          onChange = _props5.onChange;


      if (next !== prev) {
        var values = void 0;

        switch (mode) {
          case 1:
            values = (0, _modes.mode1)(prev, next);
            break;
          case 2:
            values = (0, _modes.mode2)(prev, next);
            break;
          default:
            values = next;
            (0, _warning2.default)(false, 'React Electric Slide: Invalid mode value.');
        }

        onUpdate(values.map(function (d) {
          return d.val;
        }));

        if (submit) {
          onChange(values.map(function (d) {
            return d.val;
          }));
        }

        this.setState({ values: values });
      }
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp() {
      var values = this.state.values,
          onChange = this.props.onChange;

      onChange(values.map(function (d) {
        return d.val;
      }));

      document.removeEventListener('mousemove', this.onMouseMove);
      document.removeEventListener('mouseup', this.onMouseUp);
    }
  }, {
    key: 'onTouchEnd',
    value: function onTouchEnd() {
      var values = this.state.values,
          onChange = this.props.onChange;

      onChange(values.map(function (d) {
        return d.val;
      }));

      document.removeEventListener('touchmove', this.onTouchMove);
      document.removeEventListener('touchend', this.onTouchEnd);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var values = this.state.values,
          _props6 = this.props,
          className = _props6.className,
          rootStyle = _props6.rootStyle;


      var handles = values.map(function (_ref4) {
        var key = _ref4.key,
            val = _ref4.val;

        return { id: key, value: val, percent: _this3.valueToPerc(val) };
      });

      var children = _react2.default.Children.map(this.props.children, function (child) {
        if (child.type === _Rail2.default || child.type === _Ticks2.default || child.type === _Tracks2.default || child.type === _Handles2.default) {
          return _react2.default.cloneElement(child, {
            scale: _this3.valueToPerc,
            handles: handles,
            emitMouse: _this3.onMouseDown,
            emitTouch: _this3.onTouchStart
          });
        }

        return child;
      });

      return _react2.default.createElement(
        'div',
        {
          style: rootStyle || {},
          className: className,
          ref: function ref(d) {
            return _this3.slider = d;
          }
        },
        children
      );
    }
  }]);

  return Slider;
}(_react.Component);

Slider.propTypes = {
  /**
   * CSS class name applied to the root div of the slider.
   */
  className: _propTypes2.default.string,
  /**
   * An object with any inline styles you want applied to the root div.
   */
  rootStyle: _propTypes2.default.object,
  /**
   * Two element array of numbers providing the min and max values for the slider [min, max] e.g. [0, 100].
   * It does not matter if the slider is reversed on the screen, domain is always [min, max] with min < max.
   */
  domain: _propTypes2.default.array,
  /**
   * An array of numbers. You can supply one for a value slider, two for a range slider or more to create n-handled sliders.
   * The default values should correspond to valid step values in the domain.
   * The numbers will be forced into the domain if they are two small or large.
   */
  defaultValues: _propTypes2.default.array,
  /**
   * The step value for the slider.
   */
  step: _propTypes2.default.number,
  /**
   * The interaction mode. Value of 1 will allow handles to cross.
   * Value of 2 will keep the sliders from crossing and separated by a step.
   */
  mode: _propTypes2.default.oneOf([1, 2]),
  /**
   * Set to true if the slider is displayed vertically to tell the slider to use the height to calculate positions. 
   */
  vertical: _propTypes2.default.bool,
  /**
   * Reverse the display of slider values.
   */
  reversed: _propTypes2.default.bool,
  /**
   * Function called with the values at each update (caution: high-volume updates when dragging).
   */
  onUpdate: _propTypes2.default.func,
  /**
   * Function called with the values when interaction stops.
   */
  onChange: _propTypes2.default.func,
  /**
   * Component children to render
   */
  children: _propTypes2.default.any
};

Slider.defaultProps = {
  mode: 1,
  step: 0.1,
  domain: [0, 100],
  vertical: false,
  reversed: false,
  onUpdate: noop,
  onChange: noop
};

exports.default = Slider;