'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tracks = function (_Component) {
  _inherits(Tracks, _Component);

  function Tracks() {
    _classCallCheck(this, Tracks);

    return _possibleConstructorReturn(this, (Tracks.__proto__ || Object.getPrototypeOf(Tracks)).apply(this, arguments));
  }

  _createClass(Tracks, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          left = _props.left,
          right = _props.right,
          scale = _props.scale,
          handles = _props.handles,
          emitMouse = _props.emitMouse,
          emitTouch = _props.emitTouch;

      var domain = scale.domain();
      var tracks = [];

      for (var i = 0; i < handles.length + 1; i++) {
        var s = handles[i - 1];
        var t = handles[i];

        if (i === 0 && left === true) {
          s = { id: '$', value: domain[0], percent: 0 };
        } else if (i === handles.length && right === true) {
          t = { id: '$', value: domain[1], percent: 100 };
        }

        if (s && t) {
          tracks.push({
            id: s.id + '-' + t.id,
            source: s,
            target: t
          });
        }
      }

      var renderedChildren = children({ tracks: tracks, emitMouse: emitMouse, emitTouch: emitTouch });
      return renderedChildren && _react2.default.Children.only(renderedChildren);
    }
  }]);

  return Tracks;
}(_react.Component);

Tracks.propTypes = {
  /**
   * Boolean value to control whether the left most track is included in the tracks array.
   */
  left: _propTypes2.default.bool,
  /**
   * Boolean value to control whether the right most track is included in the tracks array.
   */
  right: _propTypes2.default.bool,
  /** @ignore */
  scale: _propTypes2.default.func,
  /** @ignore */
  handles: _propTypes2.default.array,
  /** @ignore */
  emitMouse: _propTypes2.default.func,
  /** @ignore */
  emitTouch: _propTypes2.default.func,
  /**
   * A function to render to the tracks. The function receives and object with an array of tracks and functions for emitting events. `({ tracks, emitMouse, emitTouch }): element`
   */
  children: _propTypes2.default.func.isRequired
};

Tracks.defaultProps = {
  left: true,
  right: true
};

exports.default = Tracks;